----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 19.04.2021 13:37:04
-- Design Name: 
-- Module Name: Test_Etage4_Memoire - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Test_Etage4_Memoire is
--  Port ( );
end Test_Etage4_Memoire;

architecture Behavioral of Test_Etage4_Memoire is
    component Etage4_Memoire is
    Generic ( Nb_bits : Natural;
              Mem_size : Natural;
              Instruction_bus_size : Natural;
              Bits_Controle_LC : STD_LOGIC_VECTOR;
              Bits_Controle_MUX_IN : STD_LOGIC_VECTOR;
              Bits_Controle_MUX_OUT : STD_LOGIC_VECTOR);
        Port ( CLK : in STD_LOGIC;
               RST : in STD_LOGIC;
               IN_A : in STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               IN_B : in STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               IN_Instruction : in STD_LOGIC_VECTOR (Instruction_bus_size - 1 downto 0);
               OUT_A : out STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               OUT_B : out STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               OUT_Instruction : out STD_LOGIC_VECTOR (Instruction_bus_size - 1 downto 0));
    end component;
    
    signal my_CLK : STD_LOGIC := '0';
    signal my_RST : STD_LOGIC := '1';
    signal my_IN_A : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_IN_B : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_IN_Instruction : STD_LOGIC_VECTOR (2 downto 0) := (others => '0');
    signal my_OUT_A : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_OUT_B : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_OUT_Instruction : STD_LOGIC_VECTOR (2 downto 0) := (others => '0');
    
    constant Bits_Controle_LC : STD_LOGIC_VECTOR (7 downto 0) := "01111111";
    constant Bits_Controle_MUX_IN : STD_LOGIC_VECTOR (7 downto 0) := "10111111";
    constant Bits_Controle_MUX_OUT : STD_LOGIC_VECTOR (7 downto 0) := "01000000";
    
    constant CLK_period : time := 10 ns;
    
begin

    instance : Etage4_Memoire
    generic map( Nb_bits => 8,
                 Mem_size => 256,
                 Instruction_bus_size => 3,
                 Bits_Controle_LC => Bits_Controle_LC,
                 Bits_Controle_MUX_IN => Bits_Controle_MUX_IN,
                 Bits_Controle_MUX_OUT => Bits_Controle_MUX_OUT)
    port map(    CLK => my_CLK,
                 RST => my_RST,
                 IN_A => my_IN_A,
                 IN_B => my_IN_B,
                 IN_Instruction => my_IN_Instruction,
                 OUT_A => my_OUT_A,
                 OUT_B => my_OUT_B,
                 OUT_Instruction => my_OUT_Instruction);
    
    CLK_process :process
    begin
        my_CLK <= '0';
        wait for CLK_period/2;
        my_CLK <= '1';
        wait for CLK_period/2;
    end process;
    
    process 
    begin     
        my_IN_A <= "01011111" after 0 ns, "11111111" after 124 ns;
        my_IN_B <= "10100110" after 0 ns, "01011111" after 124 ns;
        my_IN_Instruction <= "000" after 0 ns, "001" after 10 ns, "010" after 20 ns, "011" after 30 ns, "100" after 40 ns, "101" after 50 ns, "110" after 60 ns, "111" after 70 ns, "000" after 80 ns, "110" after 100 ns, "111" after 110 ns, "110" after 120 ns;
        my_RST <= '0' after 125 ns;
        wait;
    end process;    
end Behavioral;